/* SPDX-License-Identifier: (GPL-2.0+ OR MIT) */
/*
 * Copyright (c) 2019 Amlogic, Inc. All rights reserved.
 */

#ifndef __S7D_CLKC_H
#define __S7D_CLKC_H

/*
 * CLKID index values
 */
#define CLKID_PLL_BASE			0
#define CLKID_FCLK_DIV2_DIV		(CLKID_PLL_BASE + 0)
#define CLKID_FCLK_DIV2			(CLKID_PLL_BASE + 1)
#define CLKID_FCLK_DIV3_DIV		(CLKID_PLL_BASE + 2)
#define CLKID_FCLK_DIV3			(CLKID_PLL_BASE + 3)
#define CLKID_FCLK_DIV4_DIV		(CLKID_PLL_BASE + 4)
#define CLKID_FCLK_DIV4			(CLKID_PLL_BASE + 5)
#define CLKID_FCLK_DIV5_DIV		(CLKID_PLL_BASE + 6)
#define CLKID_FCLK_DIV5			(CLKID_PLL_BASE + 7)
#define CLKID_FCLK_DIV7_DIV		(CLKID_PLL_BASE + 8)
#define CLKID_FCLK_DIV7			(CLKID_PLL_BASE + 9)
#define CLKID_FCLK_DIV2P5_DIV		(CLKID_PLL_BASE + 10)
#define CLKID_FCLK_DIV2P5		(CLKID_PLL_BASE + 11)
#define CLKID_FCLK_CLK50M_DIV		(CLKID_PLL_BASE + 12)
#define CLKID_FCLK_CLK50M		(CLKID_PLL_BASE + 13)
#define CLKID_GP0_PLL			(CLKID_PLL_BASE + 14)
#define CLKID_HIFI_PLL			(CLKID_PLL_BASE + 15)
#define CLKID_HIFI1_PLL			(CLKID_PLL_BASE + 16)

#define CLKID_BASIC_BASE		(CLKID_PLL_BASE + 17)
#define CLKID_RTC_DUAL_CLKIN		(CLKID_BASIC_BASE + 0)
#define CLKID_RTC_DUAL_DIV		(CLKID_BASIC_BASE + 1)
#define CLKID_RTC_DUAL_SEL		(CLKID_BASIC_BASE + 2)
#define CLKID_RTC_DUAL_CLKOUT		(CLKID_BASIC_BASE + 3)
#define CLKID_RTC_CLK			(CLKID_BASIC_BASE + 4)
#define CLKID_SAR_ADC_SEL		(CLKID_BASIC_BASE + 5)
#define CLKID_SAR_ADC_DIV		(CLKID_BASIC_BASE + 6)
#define CLKID_SAR_ADC			(CLKID_BASIC_BASE + 7)
#define CLKID_CECB_DUAL_CLKIN		(CLKID_BASIC_BASE + 8)
#define CLKID_CECB_DUAL_DIV		(CLKID_BASIC_BASE + 9)
#define CLKID_CECB_DUAL_SEL		(CLKID_BASIC_BASE + 10)
#define CLKID_CECB_DUAL_CLKOUT		(CLKID_BASIC_BASE + 11)
#define CLKID_CECB_CLK			(CLKID_BASIC_BASE + 12)
#define CLKID_SC_SEL			(CLKID_BASIC_BASE + 13)
#define CLKID_SC_DIV			(CLKID_BASIC_BASE + 14)
#define CLKID_SC			(CLKID_BASIC_BASE + 15)
#define CLKID_CDAC_SEL			(CLKID_BASIC_BASE + 16)
#define CLKID_CDAC_DIV			(CLKID_BASIC_BASE + 17)
#define CLKID_CDAC			(CLKID_BASIC_BASE + 18)
#define CLKID_12_24M_IN			(CLKID_BASIC_BASE + 19)
#define CLKID_12_24M			(CLKID_BASIC_BASE + 20)
#define CLKID_VCLK_SEL			(CLKID_BASIC_BASE + 21)
#define CLKID_VCLK2_SEL			(CLKID_BASIC_BASE + 22)
#define CLKID_VCLK_INPUT		(CLKID_BASIC_BASE + 23)
#define CLKID_VCLK2_INPUT		(CLKID_BASIC_BASE + 24)
#define CLKID_VCLK_DIV			(CLKID_BASIC_BASE + 25)
#define CLKID_VCLK2_DIV			(CLKID_BASIC_BASE + 26)
#define CLKID_VCLK			(CLKID_BASIC_BASE + 27)
#define CLKID_VCLK2			(CLKID_BASIC_BASE + 28)
#define CLKID_VCLK_DIV1			(CLKID_BASIC_BASE + 29)
#define CLKID_VCLK_DIV2_EN		(CLKID_BASIC_BASE + 30)
#define CLKID_VCLK_DIV4_EN		(CLKID_BASIC_BASE + 31)
#define CLKID_VCLK_DIV6_EN		(CLKID_BASIC_BASE + 32)
#define CLKID_VCLK_DIV12_EN		(CLKID_BASIC_BASE + 33)
#define CLKID_VCLK2_DIV1		(CLKID_BASIC_BASE + 34)
#define CLKID_VCLK2_DIV2_EN		(CLKID_BASIC_BASE + 35)
#define CLKID_VCLK2_DIV4_EN		(CLKID_BASIC_BASE + 36)
#define CLKID_VCLK2_DIV6_EN		(CLKID_BASIC_BASE + 37)
#define CLKID_VCLK2_DIV12_EN		(CLKID_BASIC_BASE + 38)
#define CLKID_VCLK_DIV2			(CLKID_BASIC_BASE + 39)
#define CLKID_VCLK_DIV4			(CLKID_BASIC_BASE + 40)
#define CLKID_VCLK_DIV6			(CLKID_BASIC_BASE + 41)
#define CLKID_VCLK_DIV12		(CLKID_BASIC_BASE + 42)
#define CLKID_VCLK2_DIV2		(CLKID_BASIC_BASE + 43)
#define CLKID_VCLK2_DIV4		(CLKID_BASIC_BASE + 44)
#define CLKID_VCLK2_DIV6		(CLKID_BASIC_BASE + 45)
#define CLKID_VCLK2_DIV12		(CLKID_BASIC_BASE + 46)
#define CLKID_ENCI_SEL			(CLKID_BASIC_BASE + 47)
#define CLKID_ENCL_SEL			(CLKID_BASIC_BASE + 48)
#define CLKID_ENCP_SEL			(CLKID_BASIC_BASE + 49)
#define CLKID_VDAC_SEL			(CLKID_BASIC_BASE + 50)
#define CLKID_HDMI_TX_PIXEL_SEL		(CLKID_BASIC_BASE + 51)
#define CLKID_HDMI_TX_FE_SEL		(CLKID_BASIC_BASE + 52)
#define CLKID_ENCI			(CLKID_BASIC_BASE + 53)
#define CLKID_ENCL			(CLKID_BASIC_BASE + 54)
#define CLKID_ENCP			(CLKID_BASIC_BASE + 55)
#define CLKID_VDAC			(CLKID_BASIC_BASE + 56)
#define CLKID_HDMI_TX_PIXEL		(CLKID_BASIC_BASE + 57)
#define CLKID_HDMI_TX_FE		(CLKID_BASIC_BASE + 58)
#define CLKID_LCD_AN_CLK_PH23_SEL	(CLKID_BASIC_BASE + 59)
#define CLKID_LCD_AN_CLK_PH23		(CLKID_BASIC_BASE + 60)
#define CLKID_LCD_AN_CLK_PH2		(CLKID_BASIC_BASE + 61)
#define CLKID_LCD_AN_CLK_PH3		(CLKID_BASIC_BASE + 62)
#define CLKID_HDMI_TX_SYS_SEL		(CLKID_BASIC_BASE + 63)
#define CLKID_HDMI_TX_SYS_DIV		(CLKID_BASIC_BASE + 64)
#define CLKID_HDMI_TX_SYS		(CLKID_BASIC_BASE + 65)
#define CLKID_HDMI_TX_PRIF_SEL		(CLKID_BASIC_BASE + 66)
#define CLKID_HDMI_TX_PRIF_DIV		(CLKID_BASIC_BASE + 67)
#define CLKID_HDMI_TX_PRIF		(CLKID_BASIC_BASE + 68)
#define CLKID_HDMI_TX_200M_SEL		(CLKID_BASIC_BASE + 69)
#define CLKID_HDMI_TX_200M_DIV		(CLKID_BASIC_BASE + 70)
#define CLKID_HDMI_TX_200M		(CLKID_BASIC_BASE + 71)
#define CLKID_HDMI_TX_AUD_SEL		(CLKID_BASIC_BASE + 72)
#define CLKID_HDMI_TX_AUD_DIV		(CLKID_BASIC_BASE + 73)
#define CLKID_HDMI_TX_AUD		(CLKID_BASIC_BASE + 74)
#define CLKID_VID_LOCK_SEL		(CLKID_BASIC_BASE + 75)
#define CLKID_VID_LOCK_DIV		(CLKID_BASIC_BASE + 76)
#define CLKID_VID_LOCK			(CLKID_BASIC_BASE + 77)
#define CLKID_VDIN_MEAS_SEL		(CLKID_BASIC_BASE + 78)
#define CLKID_VDIN_MEAS_DIV		(CLKID_BASIC_BASE + 79)
#define CLKID_VDIN_MEAS			(CLKID_BASIC_BASE + 80)
#define CLKID_ETH_RMII_DIV		(CLKID_BASIC_BASE + 81)
#define CLKID_ETH_RMII			(CLKID_BASIC_BASE + 82)
#define CLKID_ETH_125M_DIV8		(CLKID_BASIC_BASE + 83)
#define CLKID_ETH_125M			(CLKID_BASIC_BASE + 84)
#define CLKID_TS_DIV			(CLKID_BASIC_BASE + 85)
#define CLKID_TS			(CLKID_BASIC_BASE + 86)
#define CLKID_AMFC_SEL			(CLKID_BASIC_BASE + 87)
#define CLKID_AMFC_DIV			(CLKID_BASIC_BASE + 88)
#define CLKID_AMFC			(CLKID_BASIC_BASE + 89)
#define CLKID_MALI_0_SEL		(CLKID_BASIC_BASE + 90)
#define CLKID_MALI_0_DIV		(CLKID_BASIC_BASE + 91)
#define CLKID_MALI_0			(CLKID_BASIC_BASE + 92)
#define CLKID_MALI_1_SEL		(CLKID_BASIC_BASE + 93)
#define CLKID_MALI_1_DIV		(CLKID_BASIC_BASE + 94)
#define CLKID_MALI_1			(CLKID_BASIC_BASE + 95)
#define CLKID_MALI			(CLKID_BASIC_BASE + 96)
#define CLKID_MALI_STACK_0_SEL		(CLKID_BASIC_BASE + 97)
#define CLKID_MALI_STACK_0_DIV		(CLKID_BASIC_BASE + 98)
#define CLKID_MALI_STACK_0		(CLKID_BASIC_BASE + 99)
#define CLKID_MALI_STACK_1_SEL		(CLKID_BASIC_BASE + 100)
#define CLKID_MALI_STACK_1_DIV		(CLKID_BASIC_BASE + 101)
#define CLKID_MALI_STACK_1		(CLKID_BASIC_BASE + 102)
#define CLKID_MALI_STACK		(CLKID_BASIC_BASE + 103)
#define CLKID_VDEC_0_SEL		(CLKID_BASIC_BASE + 104)
#define CLKID_VDEC_0_DIV		(CLKID_BASIC_BASE + 105)
#define CLKID_VDEC_0			(CLKID_BASIC_BASE + 106)
#define CLKID_VDEC_1_SEL		(CLKID_BASIC_BASE + 107)
#define CLKID_VDEC_1_DIV		(CLKID_BASIC_BASE + 108)
#define CLKID_VDEC_1			(CLKID_BASIC_BASE + 109)
#define CLKID_VDEC			(CLKID_BASIC_BASE + 110)
#define CLKID_HEVCF_0_SEL		(CLKID_BASIC_BASE + 111)
#define CLKID_HEVCF_0_DIV		(CLKID_BASIC_BASE + 112)
#define CLKID_HEVCF_0			(CLKID_BASIC_BASE + 113)
#define CLKID_HEVCF_1_SEL		(CLKID_BASIC_BASE + 114)
#define CLKID_HEVCF_1_DIV		(CLKID_BASIC_BASE + 115)
#define CLKID_HEVCF_1			(CLKID_BASIC_BASE + 116)
#define CLKID_HEVCF			(CLKID_BASIC_BASE + 117)
#define CLKID_HCODEC_0_SEL		(CLKID_BASIC_BASE + 118)
#define CLKID_HCODEC_0_DIV		(CLKID_BASIC_BASE + 119)
#define CLKID_HCODEC_0			(CLKID_BASIC_BASE + 120)
#define CLKID_HCODEC_1_SEL		(CLKID_BASIC_BASE + 121)
#define CLKID_HCODEC_1_DIV		(CLKID_BASIC_BASE + 122)
#define CLKID_HCODEC_1			(CLKID_BASIC_BASE + 123)
#define CLKID_HCODEC			(CLKID_BASIC_BASE + 124)
#define CLKID_VPU_0_SEL			(CLKID_BASIC_BASE + 125)
#define CLKID_VPU_0_DIV			(CLKID_BASIC_BASE + 126)
#define CLKID_VPU_0			(CLKID_BASIC_BASE + 127)
#define CLKID_VPU_1_SEL			(CLKID_BASIC_BASE + 128)
#define CLKID_VPU_1_DIV			(CLKID_BASIC_BASE + 129)
#define CLKID_VPU_1			(CLKID_BASIC_BASE + 130)
#define CLKID_VPU			(CLKID_BASIC_BASE + 131)
#define CLKID_VPU_CLKB_TMP_SEL		(CLKID_BASIC_BASE + 132)
#define CLKID_VPU_CLKB_TMP_DIV		(CLKID_BASIC_BASE + 133)
#define CLKID_VPU_CLKB_TMP		(CLKID_BASIC_BASE + 134)
#define CLKID_VPU_CLKB_DIV		(CLKID_BASIC_BASE + 135)
#define CLKID_VPU_CLKB			(CLKID_BASIC_BASE + 136)
#define CLKID_VPU_CLKC_0_SEL		(CLKID_BASIC_BASE + 137)
#define CLKID_VPU_CLKC_0_DIV		(CLKID_BASIC_BASE + 138)
#define CLKID_VPU_CLKC_0		(CLKID_BASIC_BASE + 139)
#define CLKID_VPU_CLKC_1_SEL		(CLKID_BASIC_BASE + 140)
#define CLKID_VPU_CLKC_1_DIV		(CLKID_BASIC_BASE + 141)
#define CLKID_VPU_CLKC_1		(CLKID_BASIC_BASE + 142)
#define CLKID_VPU_CLKC			(CLKID_BASIC_BASE + 143)
#define CLKID_VAPB_0_SEL		(CLKID_BASIC_BASE + 144)
#define CLKID_VAPB_0_DIV		(CLKID_BASIC_BASE + 145)
#define CLKID_VAPB_0			(CLKID_BASIC_BASE + 146)
#define CLKID_VAPB_1_SEL		(CLKID_BASIC_BASE + 147)
#define CLKID_VAPB_1_DIV		(CLKID_BASIC_BASE + 148)
#define CLKID_VAPB_1			(CLKID_BASIC_BASE + 149)
#define CLKID_VAPB			(CLKID_BASIC_BASE + 150)
#define CLKID_GE2D			(CLKID_BASIC_BASE + 151)
#define CLKID_PWM_A_SEL			(CLKID_BASIC_BASE + 152)
#define CLKID_PWM_A_DIV			(CLKID_BASIC_BASE + 153)
#define CLKID_PWM_A			(CLKID_BASIC_BASE + 154)
#define CLKID_PWM_B_SEL			(CLKID_BASIC_BASE + 155)
#define CLKID_PWM_B_DIV			(CLKID_BASIC_BASE + 156)
#define CLKID_PWM_B			(CLKID_BASIC_BASE + 157)
#define CLKID_PWM_C_SEL			(CLKID_BASIC_BASE + 158)
#define CLKID_PWM_C_DIV			(CLKID_BASIC_BASE + 159)
#define CLKID_PWM_C			(CLKID_BASIC_BASE + 160)
#define CLKID_PWM_D_SEL			(CLKID_BASIC_BASE + 161)
#define CLKID_PWM_D_DIV			(CLKID_BASIC_BASE + 162)
#define CLKID_PWM_D			(CLKID_BASIC_BASE + 163)
#define CLKID_PWM_E_SEL			(CLKID_BASIC_BASE + 164)
#define CLKID_PWM_E_DIV			(CLKID_BASIC_BASE + 165)
#define CLKID_PWM_E			(CLKID_BASIC_BASE + 166)
#define CLKID_PWM_F_SEL			(CLKID_BASIC_BASE + 167)
#define CLKID_PWM_F_DIV			(CLKID_BASIC_BASE + 168)
#define CLKID_PWM_F			(CLKID_BASIC_BASE + 169)
#define CLKID_PWM_G_SEL			(CLKID_BASIC_BASE + 170)
#define CLKID_PWM_G_DIV			(CLKID_BASIC_BASE + 171)
#define CLKID_PWM_G			(CLKID_BASIC_BASE + 172)
#define CLKID_PWM_H_SEL			(CLKID_BASIC_BASE + 173)
#define CLKID_PWM_H_DIV			(CLKID_BASIC_BASE + 174)
#define CLKID_PWM_H			(CLKID_BASIC_BASE + 175)
#define CLKID_PWM_I_SEL			(CLKID_BASIC_BASE + 176)
#define CLKID_PWM_I_DIV			(CLKID_BASIC_BASE + 177)
#define CLKID_PWM_I			(CLKID_BASIC_BASE + 178)
#define CLKID_PWM_J_SEL			(CLKID_BASIC_BASE + 179)
#define CLKID_PWM_J_DIV			(CLKID_BASIC_BASE + 180)
#define CLKID_PWM_J			(CLKID_BASIC_BASE + 181)
#define CLKID_SPICC_SEL			(CLKID_BASIC_BASE + 182)
#define CLKID_SPICC_DIV			(CLKID_BASIC_BASE + 183)
#define CLKID_SPICC			(CLKID_BASIC_BASE + 184)
#define CLKID_SD_EMMC_A_SEL		(CLKID_BASIC_BASE + 185)
#define CLKID_SD_EMMC_A_DIV		(CLKID_BASIC_BASE + 186)
#define CLKID_SD_EMMC_A			(CLKID_BASIC_BASE + 187)
#define CLKID_SD_EMMC_B_SEL		(CLKID_BASIC_BASE + 188)
#define CLKID_SD_EMMC_B_DIV		(CLKID_BASIC_BASE + 189)
#define CLKID_SD_EMMC_B			(CLKID_BASIC_BASE + 190)
#define CLKID_SD_EMMC_C_SEL		(CLKID_BASIC_BASE + 191)
#define CLKID_SD_EMMC_C_DIV		(CLKID_BASIC_BASE + 192)
#define CLKID_SD_EMMC_C			(CLKID_BASIC_BASE + 193)
#define CLKID_GEN_SEL			(CLKID_BASIC_BASE + 194)
#define CLKID_GEN_DIV			(CLKID_BASIC_BASE + 195)
#define CLKID_GEN			(CLKID_BASIC_BASE + 196)
#define CLKID_SYS_AM_AXI		(CLKID_BASIC_BASE + 197)
#define CLKID_SYS_DOS			(CLKID_BASIC_BASE + 198)
#define CLKID_SYS_ETHPHY		(CLKID_BASIC_BASE + 199)
#define CLKID_SYS_MALI_GATE		(CLKID_BASIC_BASE + 200)
#define CLKID_SYS_AOCPU			(CLKID_BASIC_BASE + 201)
#define CLKID_SYS_AUCPU			(CLKID_BASIC_BASE + 202)
#define CLKID_SYS_CEC			(CLKID_BASIC_BASE + 203)
#define CLKID_SYS_SD_EMMC_A		(CLKID_BASIC_BASE + 204)
#define CLKID_SYS_SD_EMMC_B		(CLKID_BASIC_BASE + 205)
#define CLKID_SYS_SD_EMMC_C		(CLKID_BASIC_BASE + 206)
#define CLKID_SYS_SMARTCARD		(CLKID_BASIC_BASE + 207)
#define CLKID_SYS_ACODEC		(CLKID_BASIC_BASE + 208)
#define CLKID_SYS_MSR_CLK		(CLKID_BASIC_BASE + 209)
#define CLKID_SYS_IR_CTRL		(CLKID_BASIC_BASE + 210)
#define CLKID_SYS_AUDIO			(CLKID_BASIC_BASE + 211)
#define CLKID_SYS_ETH			(CLKID_BASIC_BASE + 212)
#define CLKID_SYS_UART_A		(CLKID_BASIC_BASE + 213)
#define CLKID_SYS_UART_B		(CLKID_BASIC_BASE + 214)
#define CLKID_SYS_UART_C		(CLKID_BASIC_BASE + 215)
#define CLKID_SYS_UART_D		(CLKID_BASIC_BASE + 216)
#define CLKID_SYS_UART_E		(CLKID_BASIC_BASE + 217)
#define CLKID_SYS_TS_PLL		(CLKID_BASIC_BASE + 218)
#define CLKID_SYS_GE2D			(CLKID_BASIC_BASE + 219)
#define CLKID_SYS_SPICC0		(CLKID_BASIC_BASE + 220)
#define CLKID_SYS_USB			(CLKID_BASIC_BASE + 221)
#define CLKID_SYS_I2C_M_A		(CLKID_BASIC_BASE + 222)
#define CLKID_SYS_I2C_M_B		(CLKID_BASIC_BASE + 223)
#define CLKID_SYS_I2C_M_C		(CLKID_BASIC_BASE + 224)
#define CLKID_SYS_I2C_M_D		(CLKID_BASIC_BASE + 225)
#define CLKID_SYS_I2C_M_E		(CLKID_BASIC_BASE + 226)
#define CLKID_SYS_HDMITX_APB		(CLKID_BASIC_BASE + 227)
#define CLKID_SYS_I2C_S_A		(CLKID_BASIC_BASE + 228)
#define CLKID_SYS_HDMI20_AES		(CLKID_BASIC_BASE + 229)
#define CLKID_SYS_MMC_APB		(CLKID_BASIC_BASE + 230)
#define CLKID_SYS_CPU_APB		(CLKID_BASIC_BASE + 231)
#define CLKID_SYS_VPU_INTR		(CLKID_BASIC_BASE + 232)
#define CLKID_SYS_SAR_ADC		(CLKID_BASIC_BASE + 233)
#define CLKID_SYS_PWM_J			(CLKID_BASIC_BASE + 234)
#define CLKID_SYS_GIC			(CLKID_BASIC_BASE + 235)
#define CLKID_SYS_PWM_I			(CLKID_BASIC_BASE + 236)
#define CLKID_SYS_PWM_H			(CLKID_BASIC_BASE + 237)
#define CLKID_SYS_PWM_G			(CLKID_BASIC_BASE + 238)
#define CLKID_SYS_PWM_F			(CLKID_BASIC_BASE + 239)
#define CLKID_SYS_PWM_E			(CLKID_BASIC_BASE + 240)
#define CLKID_SYS_PWM_D			(CLKID_BASIC_BASE + 241)
#define CLKID_SYS_PWM_C			(CLKID_BASIC_BASE + 242)
#define CLKID_SYS_PWM_B			(CLKID_BASIC_BASE + 243)
#define CLKID_SYS_PWM_A			(CLKID_BASIC_BASE + 244)
#define CLKID_AXI_SYS_NIC		(CLKID_BASIC_BASE + 245)
#define CLKID_AXI_RAMA			(CLKID_BASIC_BASE + 246)
#define CLKID_AXI_DEV0_MMC		(CLKID_BASIC_BASE + 247)

#define NR_CLKS				(CLKID_BASIC_BASE + 248)

#endif /* __S7D_CLKC_H */
